import peasy.*;
import java.util.*;

PeasyCam cam;
Table table;
My3DArray list;
final int n = 9;
PShape strip;

final int X = 0;
final int Y = 1;
final int Z = 2;

PShape[] strips;

void load_csv(String fileName) {
  table = loadTable(fileName, "header");

  println(table.getRowCount() + " total rows in table"); 

  for (int i = 0; i < table.getRowCount(); i++) {
    TableRow row = table.getRow(i);
    float x = row.getFloat("x");
    float y = row.getFloat("y");
    float z = row.getFloat("z");
    // double year = row.getString("C");
    list.setElementIn3DArray(x, i%n, i/n);
    list.setElementIn3DArray(y, i%n, i/n);
    list.setElementIn3DArray(z, i%n, i/n);
    
  }  
}

void setup() {
  size(200, 200, P3D);
  cam = new PeasyCam(this, 100);
  cam.setMinimumDistance(50);
  cam.setMaximumDistance(500);
  
  list = new My3DArray(n, n, 3);
  
  load_csv("data.csv");
  
  for(int j = 0; j < list.get2ndDimensionSize(); j ++) {
    for(int i = 0; i < list.get1stDimensionSize(); i ++) {
      float x = (float)list.getElementIn3DArray(i, j, X);
      float y = (float)list.getElementIn3DArray(i, j, Y);
      float z = (float)list.getElementIn3DArray(i, j, Z);
      
    }
    println();
  } 

  strips = new PShape[n - 1];
  
  for(int j = 0; j < list.get2ndDimensionSize() - 1; j ++) {
    strips[j] = createShape();
    strips[j].noStroke();
    strips[j].beginShape(TRIANGLE_STRIP);
    
    for(int i = 0; i < list.get1stDimensionSize(); i ++) {
      float x = 100 * (float)list.getElementIn3DArray(i, j, X);
      float y = 100 * (float)list.getElementIn3DArray(i, j, Y);
      float z = (float)list.getElementIn3DArray(i, j, Z);
      strips[j].vertex(x, y, z);
      println("(" + i + ", " + j + " ): " + x + ", " + y + ", " + z + " ");
      x = 100 * (float)list.getElementIn3DArray(i, j + 1, X);
      y = 100 * (float)list.getElementIn3DArray(i, j + 1, Y);
      z = (float)list.getElementIn3DArray(i, j + 1, Z);
      strips[j].vertex(x, y, z);
      println("(" + i + ", " + (j + 1) + " ): " + x + ", " + y + ", " + z + " ");
    }
    strips[j].endShape(CLOSE);
  }
  
  
  /*
  (float)list.getElementIn3DArray(0, 0, X);
  (float)list.getElementIn3DArray(0, 1, X);
  (float)list.getElementIn3DArray(1, 0, X);
  (float)list.getElementIn3DArray(1, 1, X);
  (float)list.getElementIn3DArray(2, 0, X);
  (float)list.getElementIn3DArray(2, 1, X);
  */
  
  /*
  strip = createShape();
  strip.beginShape(TRIANGLE_STRIP);
  strip.noStroke();
  strip.fill(color(255, 0, 0));
  strip.vertex(30, 75, 30);
  strip.fill(color(0, 255, 0));
  strip.vertex(40, 20, 0);
  strip.fill(color(0, 0, 255));
  strip.vertex(50, 75, 0);
  strip.fill(color(255, 0, 0));
  strip.vertex(60, 20, 30);
  strip.fill(color(0, 255, 0));
  strip.vertex(70, 75, 0);
  strip.fill(color(0, 0, 255));
  strip.vertex(80, 20, 0);
  strip.fill(color(255, 0, 0));
  strip.vertex(90, 75, 30);
  strip.endShape(CLOSE);
  */
}

void draw() {
  background(0);
  rotateX(-.5);
  // rotateY(-.5);  
  // translate(mouseX, mouseY);
  // fill(102);
  // stroke(255);
  // strokeWeight(2);
  /*
  beginShape();

  
  
  s.beginShape(TRIANGLE_STRIP);
  vertex(30, 75);
  vertex(40, 20);
  vertex(50, 75);
  vertex(60, 20);
  vertex(70, 75);
  vertex(80, 20);
  vertex(90, 75);
  endShape(CLOSE);
  */
  noStroke();
  for (PShape s: strips) {
    shape(s);
  }
  
}

/*
void draw() {
  // rotateX(-.5);
  // rotateY(-.5);
  background(0);
  // fill(255,0,0);
  stroke(255);
  fill(127);
  drawPolys();
}
*/